<template>
<div class="ml-2 mr-2">
              <b-modal @close="beforeModalCloses" :scrollable="true"  @hidden="reset" :hide-footer="true" size="xl"  ref="inputModal" id="my-modal" :title="title"  :centered="true"  >

                    <form class="" method="POST"  @submit.prevent="onSubmit()"  @reset.prevent="reset()" @keydown=" updateFormErrors($event.target.name)" @change="updateFormErrors($event.target.name)">


                    <form-wizard ref="wizard" shape="circle" color="#343a40a1" @on-loading="setLoading"  @on-change="updateStep" @on-complete="onComplete">
                            <template slot="step" slot-scope="props">
                                     <wizard-step :tab="props.tab"
                                    :transition="props.transition"
                                    :key="props.tab.title"
                                    :index="props.index">
                                    </wizard-step> 
                                </template>
                            <tab-content title="Données Générales" :before-change="carStoreStep">
                                <div class="row">
                                    <div class="col-md-4">


                                        <div class=" bloc-image align-content-lg-center align-items-center d-flex flex-column flex-direction-column">
                                            <h4 class="bold mt-2">Avatar du membre <span class="star_label">*</span></h4>
                                           <croppa
                                            ref="cropper" 
                                            v-model="croppa"
                                            :width="280"
                                            :disabled="modeSee"
                                            :height="280"
                                            initial-size="cover"
                                            :quality="2"
                                            :zoom-speed="7"
                                            :placeholder-font-size="16"
                                            placeholder="Chargez votre avatar ici"
                                            canvas-color="#ebebeb"
                                            :initial-image=" entity ? ( entity.hasPhoto ?'/storage/featured/'+entity.avatar: null) : null"
                                            @draw="updateImage"
                                            @loading-end="updateImage"
                                            @file-size-exceed="onFileSizeExceed"
                                            :file-size-limit="502400"
                                            @file-type-mismatch="onFileTypeMismatch"





                                           ></croppa>
                                            <div class="btns" v-if="!modeSee">
                                                <button @click.prevent="zoomIn()"><i class="fas fa-search-plus"></i></button>
                                                <button @click.prevent="zoomOut()"><i class="fas fa-search-minus"></i></button>
                                                 <button @click.prevent="rotateLeft()"><i class="fas fa-undo"></i></button>
                                                <button @click.prevent="rotateRight()"><i class="fas fa-redo"></i></button>
                                            </div>
                                            <div v-if="false" class="image-uploader-content profile-image-preview mb-2">
                                                <img src="/img/entreprise_defaut.png" alt="" class="img-fluid">
                                            </div>
                                            <div  v-if="false"  :class="['file is-fullwidth mt-2  is-disable']" style="min-width:292px;">
                                                <label class="file-label" >
                                                    <input class="file-input" @change="readURL" type="file" name="avatar" accept="image/x-png,image/gif,image/jpeg">
                                                    <span class="file-cta w-100">
                                                    <span class="file-icon">
                                                        <div v-if="imageProfileIsLoading" class="kt-spinner kt-spinner--v2 kt-spinner--danger ml-2 "></div>
                                                        <i class="fas fa-camera mr-2" v-else ></i>
                                                    </span>
                                                    <span class="file-label">
                                                        Charger l'image de profil
                                                    </span>
                                                    </span>
                                                </label>
                                            </div>
                                        </div>
                                            
                                    </div>
                                    <div class="col-md-8">

                                <div class="form-row">
                                        <div class="form-group col-md-4">
                                            <label for="inputState4">Civilité <span class="star_label">*</span></label>
                                            <select :disabled="modeSee" name="civilite" v-model="form.civilite" class="form-control" style="min-height:40px;display:block;padding:8px 40px 8px 8px;border-radius:5px;border:1px solid #e8e8e8;background:#fff;font-size:14px;">
                                                <option value="" class="text-capitalize">Choix de la civilité</option>
                                                <option v-for="(civilite,index) in _civilites" :key="index" :value="civilite" class="text-capitalize">{{civilite}}</option>
                                            </select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('civilite')" v-text="form.errors.get('civilite')"></span>

                                        </div>
                                        <div class="form-group col-md-4">
                                            <label class="">Nom <span class="star_label">*</span></label>
                                            <input :disabled="modeSee" placeholder="Entrez le nom du membre"  class="form-control form-control-md form-custom-input-sm" name="nom" v-model="form.nom" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('nom')" v-text="form.errors.get('nom')"></span>
                                        </div>
                                        <div class="form-group col-md-4">
                                            <label class="">Prénom  <span class="star_label">*</span></label>
                                            <input :disabled="modeSee" placeholder="Entrez le prénom du membre"  class="form-control form-control-md form-custom-input-sm" name="prenom" v-model="form.prenom" type="text" />

                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('prenom')" v-text="form.errors.get('prenom')"></span>
                                        </div>
                                        <div class="form-group col-md-5 ">
                                            <label class="">Date de naissance <span class="star_label">*</span></label>
                                            <vc-date-picker  :input-props='{disabled:modeSee,placeholder: "Entrez votre date de naissance",style:"min-height:40px;display:block;padding:8px 40px 0 8px;border-radius:5px;border:1px solid #e8e8e8;background:#fff;font-size:14px;"}'
                                                @input="datepickerEvent($event,'date_naissance')" 
                                                is-expanded  single-date-="single" name="date_naissance" 
                                                :class="['', form.errors.has('date_naissance')? ' is-invalid' : '']"
                                                v-model="date_naissance" type="text">
                                                </vc-date-picker>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_naissance')" v-text="form.errors.get('date_naissance')"></span>
                                        </div>
                                        <div class="form-group col-md-7">
                                            <label for="inputState4">Nationalité <span class="star_label">*</span></label>
                                            <multi-select :disabled="modeSee" class="country"
                                                    no-ptions="Aucun type de véhicule disponible" open-direction="bottom" name="nationalites"
                                                    v-model="nationalites"  :options="_pays"
                                                :show-labels="false"  :clear-on-select="false" :multiple="true" :taggable="true" 
                                                :close-on-select="true" :limit="3"  placeholder="Choisissez les nationalités" label="libelle" track-by="id">
                                                    <template slot="option"  slot-scope="props">
                                                                <!-- <img width="20" class="option__image" :src="'/storage/flags/'+props.option.code2+'.png'" :alt="props.option.code1"> -->
                                                                <div class="option__desc"><span class="option__title">{{ props.option.libelle }}</span></div>
                                                    </template>
                                            </multi-select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('nationalites')" v-text="form.errors.get('nationalites')"></span>

                                        </div>
                                        <div class="form-group col-md-5">
                                            <label for="inputState4">Statut marital <span class="star_label">*</span></label>
                                            <select :disabled="modeSee" name="statut_marital" v-model="form.statut_marital" class="form-control" style="min-height:40px;display:block;padding:8px 40px 8px 8px;border-radius:5px;border:1px solid #e8e8e8;background:#fff;font-size:14px;">
                                                <option value="">Choix du statut marital</option>
                                                <option :value="marital" v-for="(marital,index) in _statuts_maritaux" :key="index">{{marital}}</option>
                                            </select>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('statut_marital')" v-text="form.errors.get('statut_marital')"></span>

                                        </div>
                                        <div class="form-group col-md-7">
                                                    <label class="">Promotion (Année de sortie) <span class="star_label">*</span></label>

                                                    <multi-select
                                                        
                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                        name="promotion" 
                                                        v-model="form.promotion" :options="_promotions" @input="trackpromotion"
                                                        :show-labels="false" :disabled="modeSee" :searchable="true" :clear-on-select="false"
                                                        :close-on-select="true"  placeholder="Choisissez la promotion"
                                                        >
                                                    </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('promotion')" v-text="form.errors.get('promotion')"></span>
                                        </div>

                                </div>
                                <div class="form-row">


                                                <div class="form-group col-md-12">
                                                    <label class="">Description <span class="star_label">*</span><small class="float-right">(Vous avez {{ caracteres_restants }} caractères restants)</small></label>
                                                    <textarea :disabled="modeSee" placeholder="Parlez-nous de vous en moins de 150 caractères... "  class="form-control form-control-md form-custom-input-sm" name="description" v-model="form.description" type="text"></textarea>

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('description')" v-text="form.errors.get('description')"></span>
                                                </div>
                                            
                                </div>

                                    </div>
                                </div>



                            </tab-content>
                            <tab-content title="Activité Professionnelle" :before-change="carStoreStep">
                                        <div class="form-group col-md-12">
                                                    <label class="">Pays de résidence <span class="star_label">*</span></label>

                                                    <multi-select :disabled="modeSee" class="country"
                                                        no-ptions="Aucun revendeur disponible" open-direction="bottom"
                                                        v-model="pays"  :options="_pays"
                                                        @input="trackPays" 
                                                        :show-labels="false" :searchable="true" :clear-on-select="false"
                                                        :close-on-select="true"  placeholder="Le nom du pays" label="libelle" track-by="id">
                                                            <template slot="option" slot-scope="props">
                                                                <!-- <img width="20" class="option__image" :src="'/storage/flags/'+props.option.code2.toLowerCase()+'.png'" :alt="props.option.code1"> -->
                                                                <div class="option__desc"><span class="option__title">{{ props.option.libelle }}</span></div>
                                                            </template>
                                                            <span slot="noOptions">
                                                               Aucune pays disponible 
                                                           </span>
                                                           <span slot="noResult">Aucun élement trouvé</span>
                                                    </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('pays_residence_id')" v-text="form.errors.get('pays_residence_id')"></span>
                                                </div>
                                        <div class="form-row">

                                                <div class="form-group col-md-6">
                                                    <label class="">Secteur d'activité <span class="star_label">*</span></label>
                                                  <multi-select :disabled="modeSee" @input="trackSecteurActivite" name="secteur_activite_id"
                                                        v-model="secteur_activite" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez le secteur d'activité"
                                                        :options="_secteurs"   label="libelle" track-by="id">

                                                           <span slot="noOptions">
                                                               Aucune secteur d'activité disponible 
                                                           </span>
                                                           <span slot="noResult">Aucun élement trouvé pour votre recherche</span>
                                                    </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('secteur_activite_id')" v-text="form.errors.get('secteur_activite_id')"></span>
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label class="">Formation </label>
                                                        <multi-select :disabled="modeSee" @input="trackFormation" name="formation_id"
                                                        v-model="formation" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez le secteur d'activité"
                                                        :options="_formations"   label="libelle" track-by="id">
                                                            <span slot="noOptions">
                                                               Aucune formation disponible 
                                                           </span>
                                                           <span slot="noResult">Aucun élement trouvé pour votre recherche</span>
                                                        </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('formation_id')" v-text="form.errors.get('formation_id')"></span>
                                                </div>
                                        </div>

                                        <div class="form-row">
                                                <div class="form-group col-md-12">
                                                    <label class="">Compétences <span class="star_label">*</span></label>
                                                        <multi-select :disabled="modeSee" @input="trackCompetence" name="formation_id"
                                                        v-model="competences" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Choisissez le secteur d'activité"
                                                        :options="_competences" :multiple="true" :max-height="150" :max="3" :show-no-results="true"  label="libelle" track-by="id">
                                                           <span slot="noOptions">
                                                               Aucune compétence disponible 
                                                           </span>
                                                           <span slot="noResult">Aucun élement trouvé pour votre recherche</span>
                                                        </multi-select>
                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('competences')" v-text="form.errors.get('competences')"></span>
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label class="">Profession actuelle <span class="star_label">*</span></label>
                                                    <input :disabled="modeSee" placeholder="Entrez le nom de la profession actuelle"  class="form-control form-control-md form-custom-input-sm" name="derniere_profession" v-model="form.derniere_profession" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('derniere_profession')" v-text="form.errors.get('derniere_profession')"></span>
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label class="">Entreprise actuelle <span class="star_label">*</span></label>
                                                    <input :disabled="modeSee" placeholder="Entrez le nom de l'entreprise actuelle"  class="form-control form-control-md form-custom-input-sm" name="activite_actuelle" v-model="form.activite_actuelle" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('activite_actuelle')" v-text="form.errors.get('activite_actuelle')"></span>
                                                </div>
                                            </div>
                            </tab-content>
                            <tab-content title="Contact" :before-change="carStoreStep">
                                <div class="">
                                    <div class="form-row">
                                                <div class="form-group col-md-6">
                                                    <label class="">Téléphone 1 <span class="star_label">*</span></label>
                                                    <input :disabled="modeSee" placeholder="Entrez le numéro de téléphone 1" class="form-control form-control-md form-custom-input-sm" name="phone1" v-model="form.phone1" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('phone1')" v-text="form.errors.get('phone1')"></span>
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label class="">Téléphone 2</label>
                                                    <input :disabled="modeSee" placeholder="Entrez le numéro de téléphone 2" class="form-control form-control-md form-custom-input-sm" name="phone2" v-model="form.phone2" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('phone2')" v-text="form.errors.get('phone2')"></span>
                                                </div>
                                        </div>
                                        <div class="form-row">
                                                <div class="form-group col-md-6">
                                                    <label class="">E-mail <span class="star_label">*</span></label>
                                                    <input :disabled="modeSee" placeholder="Entrez l'adresse e-mail"  class="form-control form-control-md form-custom-input-sm" name="email" v-model="form.email" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('email')" v-text="form.errors.get('email')"></span>
                                                </div>
                                         <div class="form-group col-md-6">
                                                    <label class="">Facebook</label>
                                                    <input :disabled="modeSee" placeholder="Entrez le facebook"  class="form-control form-control-md form-custom-input-sm" name="facebook" v-model="form.facebook" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('facebook')" v-text="form.errors.get('facebook')"></span>
                                                </div>
                                        </div>
                                                                                            <div class="form-row">
       
                                                <div class="form-group col-md-6">
                                                    <label class="">twitter</label>
                                                    <input :disabled="modeSee" placeholder="Entrez le twitter"  class="form-control form-control-md form-custom-input-sm" name="twitter" v-model="form.twitter" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('twitter')" v-text="form.errors.get('twitter')"></span>
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label class="">Linkedin </label>
                                                    <input :disabled="modeSee" placeholder="Entrez le linkedin" class="form-control form-control-md form-custom-input-sm" name="linkedin" v-model="form.linkedin" type="text" />

                                                    <span class="m-form__help m--font-danger"  v-if="form.errors.has('linkedin')" v-text="form.errors.get('linkedin')"></span>
                                                </div>
                                        </div>
                                        
                                </div>

                            </tab-content>
                            <template slot="footer" slot-scope="props">
                                <div class="wizard-footer-left">
                                <wizard-button  v-if="props.activeTabIndex > 0 " @click.native="props.prevTab()" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading"><i class="la la-arrow-left mr-2"></i> Retour </wizard-button>
                                </div>
                                <div class="wizard-footer-right">
                                <wizard-button v-if="!props.isLastStep" @click.native=" props.nextTab()" class="wizard-footer-right btn btn-block btn-primary btn-lg" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading || FileIsLoading">
                                    <span v-if="!isLoading">
                                        Suivant <i class="la la-arrow-right ml-2"></i>
                                    </span>
                                    <span v-else class="pr-2">
                                        <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                        <span>Chargement</span>
                                    </span>
                                    </wizard-button>
                                 <template  v-else>

                                        <wizard-button v-if="props.isLastStep && modeSee==false" @click.native="onSubmit" class="wizard-footer-right finish-button" :style="props.fillButtonStyle" :disabled="form.errors.any() || isLoading">

                                    <span v-if="!isLoading">
                                        Terminer <i class="la la-check ml-2"></i>
                                    </span>
                                    <span v-else class="pr-2">
                                        <i class="m-loader m-loader--light m-loader--right ml-4 pr-1"></i>
                                        <span>Chargement</span>
                                    </span>
                                    </wizard-button>
                                 </template>

                                </div>
                            </template>
                    </form-wizard>
                </form>

              </b-modal>
</div>
</template>

<script>
import {FormWizard,WizardButton,WizardStep, TabContent} from 'vue-form-wizard'
import 'vue-form-wizard/dist/vue-form-wizard.min.css'
import { mapGetters } from 'vuex'
//component code

   import Form from "./../../classes/Form"
   //import { mapState } from 'vuex'
    export default {
        data()
        {
            return{
                croppa: {},
                isLoading:false,
                imageProfileIsLoading:false,
                imageGalleryIsLoading:false,
                FileIsLoading:false,
                filesAdded:[],
                modeEdit:false,
                modeSee:false,
                modeles : [],
                FileLimit:4,
                isMounted:false,
                fileCounter:0,
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                pays:"",
                permis:"",
                tvehicule:"",
                secteur_activite:"",
                formation:"",
                nationalites:"",
                entity:null,
                date_naissance:"",
                competences:'',

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                form : new Form(
                    {
                        //1
                        id:"",
                        avatar:"",
                        secteur_activite_id:"",
                        statut_marital: "",
                        promotion: "",
                        date_naissance:"",
                        civilite: "",
                        description:"",
                        nationalites: [],
                        prenom:"",
                        nom: "",
                        step:0,

                        //2 Adresse

                        secteur_activite_id: "",
                        derniere_profession: "",
                        activite_actuelle: "",
                        formation_id: "",
                        pays_residence_id: "",
                        competences: "",

                        //2 Activite

                        secteur_activite_id: "",
                        derniere_profession: "",
                        activite_actuelle: "",
                        formation_id: "",
                        pays_residence_id: "",
                        competences: "",

                        // 3 contact
                        phone1: "",
                        phone2: "",
                        email: "",
                        facebook: "",
                        twitter: "",
                        linkedin: "",


                        

                        //moteurs


                        //mesures physiques

                  }),

            }
        },
        computed:
         {
            ...mapGetters({_civilites:'params/_civilites',_statuts_maritaux:'params/_statuts_maritaux',_formations:'params/_formations',_competences:"params/_competences",_pays:"params/_pays",_secteurs:'params/_secteurs',_promotions:"params/_promotions"}),

             //...mapState(["pays"]),
           setTitle: function()
            {
               
            },
            caracteres_restants :function()
            {

                   if(this.form.description.length>150)
                   return 0
                   else
                   return 150 - this.form.description.length
             
            },
            title ()
            {
            return  this.modeEdit ? " Modification d'un membre" : ( this.modeSee ? "Détail d'un membre"  : " Ajout d'un membre")
            },
            ModalAction ()
            {
            return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            Modeles ()
            {
              if(this.marque==null || this.marque=="")
              return  []
              else
              return this.marque.modeles
            },
            //Determine si le formulaire est à la derniere etape
            lastStep()
            {
              if(this.$refs.wizard) return this.$refs.wizard.isLastStep
              return   false
            },
            //Determine si le formulaire a des images
            hasImages()
            {
    
              return false
            },
            promotionAnnee()
            {

              return false
            },
            //Fusions les tableaux d'options
             OptionsPack ()
            {

              var arr = []
              _.merge(arr,[this.securites,this.plaisirs,this.conforts])
              return _.uniq(_.flatten(arr))

            },
            //Recupere les ids des tableaux d'options
             OptionsIds()
            {

              if(this.nationalites.length!=0)
              {
                  var arr = this.nationalites.map( e => {return e.id});
                  this.form.nationalites = arr
                  return arr
              }
              else
              this.form.nationalites = []
              return []


            },
            avatarHasBeenChosen()
            {
                return this.$refs.cropper.chosenFile != null ? true : false
                if(isDefined(this.$refs.cropper))
                {
                    return this.$refs.cropper.chosenFile != null ? true : false
                }
                else
                return false
            }

        },
        created()
        {

        },
        mounted()
         {

             //les options sont chargées
             this.isMounted = true;
             this.visible = true;
            window.event.$on('new-member-event',(e) => 
            {
              this.modeEdit = false
              this.showModalOnCreate()
            })
            window.event.$on('see-member-event',(e) => 
            {
              this.modeSee = true
              this.modeEdit = false
              this.entity = e.entity
              this.initUpdate()
              this.showModalOnCreate()
            })
            window.event.$on('update-member-event',(e) => 
            {
              this.modeEdit = true
              this.entity = e.entity
              this.initUpdate()
              this.showModalOnCreate()
            })
              this.$on('initOption', e => {
                this.initForm()


            })
        },
        methods:
        {
            beforeModalCloses()
            {
                this.$refs.cropper.remove();
               log("ok")
            },
            zoomIn()
            {
            this.$refs.cropper.zoomIn()
            },
            zoomOut()
            {
            this.$refs.cropper.zoomOut()
            },
            rotateLeft()
            {
            this.$refs.cropper.rotate(-1)
            },
            rotateRight()
            {
            this.$refs.cropper.rotate()
            },
                onFileTypeMismatch (file) {
                alert('Type de fichier invalide. Please choose a jpeg or png file.')
                },
                onFileSizeExceed (file) {
                alert('File size exceeds. Please choose a file smaller than 100kb.')
                },
            datepickerEvent(event,name)
                {
                    log(name)
                    if(name=="date_naissance")
                    {
                      
                        this.form.date_naissance = moment(event).format('YYYY-MM-DD')
                        this.form.checkError(name)

                    }
                },
          showModalOnCreate()
            {

                this.modeEdit = false
                this.reset()

                this.$refs['inputModal'].show()

            },
             initForm()
            {

                    this.form.step="",

                    //EC
                    this.form.avatar="",
                    this.form.statut_marital= "",
                    this.form.nationalites="",
                    
                    this.form.modele_id="",
                    this.form.prenom="",
                    this.form.date_naissance= "",
                    this.form.civilite = ""
                    this.form.description = ""
                    this.form.nom="",
                    this.form.promotion= "",
                    
                    //RPO
                    this.form.secteur_activite_id="",
                    this.form.formation_id="",
                    this.form.derniere_profession= "",
                    this.form.activite_actuelle= "",
                    this.form.formation_id= "",
                    this.form.competences= "",
                    this.form.pays_residence_id= "",

                    //contact
                    this.form.phone1= "",
                    this.form.phone2= "",
                    this.form.linkedin= "",
                    this.form.twitter= "",
                    this.form.email= "",
                    this.form.facebook= "",
                    this.form.siteweb= ""

                    //Adresse
                    this.pays = ""
                    this.competences = ""
                    this.date_naissance=""
                    this.nationalites = ""
                    this.secteur_activite = ""
                    this.formation = ""
                    this.civilite = ""


            },
            initUpdate()
            {

                    this.form.step="0"
                    this.form.id=this.entity.id

                    //General
                    this.form.avatar=""
                    this.form.statut_marital= this.entity.statut_marital
                    this.form.nom=this.entity.nom
                    this.form.prenom=this.entity.prenom
                    this.form.promotion=this.entity.promotion
                    this.form.description=this.entity.description
                    this.form.civilite = this.entity.civilite
                    this.form.date_naissance = this.entity.date_naissance
                    this.date_naissance= moment(this.form.date_naissance).toDate()

                    //contact
                    this.form.phone1= this.entity.phone1
                    this.form.phone2= this.entity.phone2
                    this.form.siteweb= this.entity.siteweb
                    this.form.linkedin= this.entity.linkedin
                    this.form.twitter= this.entity.twitter
                    this.form.email= this.entity.email
                    this.form.facebook= this.entity.facebook

                

                    //Adresse
                    this.form.secteur_activite_id=this.entity.secteur_activite_id
                    this.form.derniere_profession= this.entity.derniere_profession
                    this.form.activite_actuelle= this.entity.activite_actuelle
                    this.form.formation_id= this.entity.formation_id
                    this.form.pays_residence_id= this.entity.pays_residence_id
                    this.nationalites = this.entity.nationalites
                    this.competences= this.entity.competences

                    this.formation = this._formations.find(elem => {
                        return elem.id == this.form.formation_id
                    })
                    this.form.competences = this.entity.competences.map( e => {return e.id});
                    this.pays = this._pays.find(elem => {
                        return elem.id == this.form.pays_residence_id
                    })

                     this.secteur_activite= this._secteurs.find(elem => {
                        return elem.id == this.form.secteur_activite_id
                    })
                   

            },
            updateFormErrors(name)
            {
                if(this.form.errors.any()==true)
                {
                    //on retire l erreur
                    this.form.errors.clear(name)
                    //on verifie s il  n ya plus d erreurs
                    if(this.form.errors.any()==false)
                    {
                        this.$refs.wizard.tabs[this.form.step].validationError = null
                    }
                }

            },

          //ajout de la voiture par étape
          carStoreStep()
          {
                if(this.modeSee)
                {
                  return true
                }
                return new Promise((resolve, reject) => {
                    axios.post('/api/membres', this.form.data())
                        .then(response => {

                            resolve(true);
                        })
                        .catch(error => {
                            this.form.onFail(error.response.data);

                            reject(error.response.data);
                        });
                   });
          },
          onSubmit()
           {
               this.isLoading = true

               if(this.modeEdit)
               {
                   this.$store.dispatch('members/updateMember',this.form).then((response) =>
                   {
                         this.isLoading = false
                        flash("<span>Modifié <strong>avec succès</strong></span>",'success')
                        this.initForm()
                        this.$refs['inputModal'].hide()
                   },
                   (error) => {
                        this.isLoading = false
                        this.form.onFail(error.response.data);
                        reject(error.response.data);
                    
                    }

                    )
       
               }
               else
               {
                   this.$store.dispatch('members/addMember',this.form).then((response) =>
                   {
                       this.isLoading = false
                        flash("<span>Enregistré <strong>avec succès</strong></span>",'success')
                        this.initForm()
                        this.$refs['inputModal'].hide()
                   },
                   (error) => {

                        this.isLoading = false
                        this.form.onFail(error.response.data);
                        reject(error.response.data);
                    })
               }
           },
            updateImage()
            {
               this.form.avatar =this.$refs.cropper.generateDataUrl('image/jpeg');
            },
            updateStep(prevIndex, nextIndex)
            {
                if(!this.form.errors.any())
                {

                  this.form.step = nextIndex
                  this.$forceUpdate()
                }
            },

            setLoading(value)
            {
               this.isLoading = value
            },
            addSecuriteOpt(option)
            {
              console.log(option)
            },
            //Charge l'image
            readURL(event)
            {
                this.imageProfileIsLoading = true
                  var input = event.srcElement;
                  if (input.files && input.files[0]) {
                var reader = new FileReader();
                  var vm = this
                reader.onload = function (e)
                {
                    $('.image-uploader-content img').attr('src', e.target.result);
                    vm.form.avatar = e.target.result;
                    //console.log(e.target.result)
                    vm.imageProfileIsLoading = false
                };
                reader.readAsDataURL(input.files[0]);
            }},
            //Charge l'image
            onUploadDocument(name,event)
            {

                  var input = event.srcElement;
                  if (input.files && input.files[0])
                   {
                    var reader = new FileReader();
                    var vm = this
                    reader.onload = function (e)
                    {

                            vm.form[name].fichier = e.target.result;
                            vm.form[name].nom_fichier=input.files[0].name
                            vm.form[name].hasFile=true

                    };
                    reader.readAsDataURL(input.files[0]);
                   }
            },
             //Retire l'image des
            removeImage(index)
            {
               this.form.images.splice(index,1)

            },
            //Charge les images de la galerie
            readURLGalerie(event)
            {
                  var input = event.srcElement;
                  this.imageGalleryIsLoading = true
                  if (input.files && input.files[0])
                  {

                      var index = 0
                      var vm = this
                      this.fileCounter = input.files.length
                      this.imageGalleryIsLoading = true
                      for(index;index<input.files.length;index++)
                      {
                        var reader = new FileReader();
                        reader.onload = function (e)
                        {
                            //$('.image-uploader-content img').attr('src', e.target.result);
                            //vm.form.avatar = e.target.result;
                            vm.form.images.push(e.target.result)
                            vm.fileCounter--

                        };
                        reader.readAsDataURL(input.files[index]);
                      }
                   }
            },
             registerFile(event)
            {
              this.form.images.push(event.dataURL)
              this.FileIsLoading = false
            },
            removedfileFromDropzone(file, error, xhr)
            {
                var oldSize = this.form.images.length
                this.form.images= this.form.images.filter(e => { return e !==file.dataURL })
                if(this.form.images.length != oldSize)
                {
                    this.FileLimit++
                }

            },
            fileAdded(event)
            {

                 
              var reader = new FileReader();
              var vm = this
              reader.onload = function (e)
              {
                    if(vm.FileLimit > 0)
                    {
                        vm.form.images.push(e.target.result)
                        vm.FileLimit--;
                    }
                    else
                    {
                        vm.$refs.dropzone.removeFile(event)
                    }
                   
            
              };
            
             reader.readAsDataURL(event);
             
       
              
            },
            maxFilesReached(file)
            {
              //console.log(file)
              //this.$refs.dropzone.removeFile(file)
            },
            onComplete()
            {

            },
            showModalOnCreate()
             {
                this.$refs['inputModal'].show()

             },
             showModalOnEdit(entity)
             {
                  this.modeEdit = true
                  this.form.nom = entity.nom
                  this.form.id=entity.id
                  this.$refs['inputModal'].show()
             },
              reset()
             {
                  this.initForm()
                  this.modeEdit = false
                  this.modeSee = false
                  this.form.errors.clearAll()
                  this.entity=""
             },

             // Events
             trackSecteurActivite(e)
             {
                 if(e!=null)
                 {
                   this.form.secteur_activite_id = e.id

                 }
                 else
                 {

                 }
                 this.updateFormErrors("secteur_activite_id");


             },
              trackModele(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
            trackTM(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
             trackCompetence(e)
             {
                var arr = this.competences.map( ex => {return ex.id});
                this.form.competences = arr
                 this.updateFormErrors("competences");
             },
            trackFormation(e)
             {
                if(e!=null)
                 {
                   this.form.formation_id = e.id
                 }
                 else
                 {
                    this.form.formation_id = ""
                 }
                 this.updateFormErrors("formation_id");
             },
              trackPays(e)
             {
                 if(e!=null)
                 {
                   this.form.pays_residence_id = e.id
                 }
                 else
                 {
                    this.form.pays_residence_id = ""
                 }
                 this.updateFormErrors("pays_residence_id");
             },
             trackpromotion(e)
             {
                 if(e!=null)
                 {
                   this.form.promotion = e
                 }
                 else
                 {
                    this.form.promotion = ""
                 }
                 this.updateFormErrors("promotion");
             }
        },
        components:
         {
          FormWizard,
          TabContent,WizardButton,WizardStep
         },
         watch:
         {
             "fileCounter":function(val)
             {
                 if(this.fileCounter==0 && this.imageGalleryIsLoading == true)
                 {
                     this.imageGalleryIsLoading = false
                 }
             },
            "OptionsIds":function(val)
             {
                 this.form.options = val
             },
             "form.secteur_activite_id" : function(value)
             {
                 if(value!="")
                 {
                  this.updateFormErrors("secteur_activite_id");
                 }

             },

             "form.modele_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("modele_id");
             },
            "form.email" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("email");
             }
             ,
            "form.facebook" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("facebook");
             }
             ,
            "form.nationalites" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("nationalites");
             }
         }

    }
</script>
<style lang="scss">
.wizard-header,.wizard-progress-with-circle {
    display:none !important;
}
.dataTables_info select {
    width: auto;
    display: inline-block;

        height: calc(1.5em + 1rem + 2px);
    padding-top: 0.5rem;
    padding-bottom: 0.5rem;
    padding-left: 1rem;
    font-size: 0.875rem;
    padding: 0.65rem 2rem 0.65rem 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    vertical-align: middle;
    background: #fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") no-repeat right 1rem center/8px 10px;
    border: 1px solid #e2e5ec;
    border-radius: 0.25rem;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;

}
.vue-dropzone
{
    width: 100%;
    margin-top: 34px;
    min-height: 270px;
    position:relative;
    display: flex;
    -webkit-box-pack: center !important;
    justify-content: center !important;
    
}
.dz-message{
    width: 50%;
    margin: auto !important;
    position: absolute;
    top: 50%;
    left: 50%;
    -webkit-transform: translate(-50%,-50%);
    -ms-transform: translate(-50%,-50%);
    transform: translate(-50%,-50%);
}

.profile-image-preview {
    width: 300px !important;
}
.profile-image-preview img {
    width: inherit !important;
    height: inherit !important;
    -o-object-fit: contain !important;
    object-fit: contain !important;
}
.country .multiselect__option
{
    display: flex;
}
.country .multiselect__option img
{
    margin-right: 10px;
    color: rgba(0, 0, 0, 0) !important;

}
.recap h6
{
    font-weight: 600!important;
    margin-bottom: .75rem!important;
    font-size: 0.975rem;
}
.recap table tr td:first-child
{
    font-weight: 900;
}
.recap table tr td:last-child
{
   padding-left:10px;
   color:#80808f!important;
   line-height: 1.5;
     white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
    position: relative;
  display: inline-block;
      max-width: 160px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
}
.croppa-container {

border-radius: 10px;
   width:280px;
   position:relative;

 }
    .croppa-container .icon-remove
   {
      position:absolute;
      bottom:5px;
   }
 .croppa-container:hover {
   opacity: 1;
 }
 .bloc-image .croppa-container .icon-remove {
    top: -10.25px !important;
    right: -9px !important;
}
</style>
